
// The following function product(a) returns the product of all  numbers in
// array a.

function product(a: array<int>): int
    requires a!=null;
    reads a;
{
  productAux(a,0,a.Length-1)
}

// It is defined in terms of the auxiliary function productAux(a,from,to),
// which returns the product of all  numbers in array a between (and including)
// from and to. It calculates the product starting from the rightmost index of
// the interval [from..to].

function productAux(a: array<int>, from:nat, to:int): int
    requires a!=null && to < a.Length;
    reads a;
    decreases to-from;
{
  if ( from > to )
    then 1
  else if ( from==to )
    then a[to]
    else productAux(a,from,to-1) * a[to]
}


// Question 1
// Consider the definition of the method Product, which calculates the product
// of all numbers in an array a, by traversing the array left-to-right.
// Prove that the code of Product satisfies its specification.

method Product(a: array<int>)
  returns (p: int)
  requires a != null;
  ensures p == product(a);
{
  var i := 0;
  p := 1;

  while (i < a.Length)
    invariant ???;
  {
    p := p * a[i];
    i := i + 1;
  }
}
